# Voice commands for Emacs

# ---------------------------------------------------------------------------
# Buffer and File Manipulation

Switch Buffer = {Alt+x}get-next-buffer{Enter};
Switch Buffer 1..20 = "{Ctrl+x}{Ctrl+b}{Down $1} ";
Kill Buffer      = {Ctrl+x}k{Enter};
Two Buffers      = {Ctrl+x}2;
Two Buffers Across = {Ctrl+x}3;
One Buffer       = {Ctrl+x}1;
Other Buffer     = {Ctrl+x}o;
One Other Buffer = {Ctrl+x}0;
Buffer List      = {Ctrl+x}{Ctrl+b};
Revert Buffer = {Alt+x}revert-buffer{Enter}yes{Enter};
Print Buffer = {Ctrl+c}p;
Buffer Shell = {Alt+x}shell{Enter};
Buffer Scratch = {Ctrl+x}b*scratch*{Enter};
[Toggle] Read Only = {Ctrl+x}{Ctrl+q};
[Toggle] Fill Mode = {Alt+x}auto-fill-mode{Enter};

Line Number = {Alt+Shift+g};
What Line = {Alt+x}what-line{Enter};

Open File  = {Ctrl+x}{Ctrl+f};
Save File  = {Ctrl+x}{Ctrl+s};
Save All   = {Ctrl+x}s;
Save As    = {Ctrl+x}{Ctrl+w};
Wrong File = {Ctrl+x}{Ctrl+v};
Hit Close  = {Ctrl+x}{Ctrl+c};
Recover File = {Alt+x}recover-file{Enter}{Enter}yes{Enter};
Make Directory = {Alt+x}make-directory{Enter}{Enter};

Reload Dot Emacs = {Alt+x}load-library{Enter}~/.emacs{Enter};
Exit Emacs = {Ctrl+x}{Ctrl+c};

# ---------------------------------------------------------------------------
# Text Editing

### Editing Characters and Words

<number> := 1..40;
<direction> := Up | Down | Left | Right;
<left_right> := Left=b | Right=f;

<number> <direction> = "{$2 $1}";
<number> <direction> (Start=a | End=e) = "{$2 $1}{Ctrl+$3}";

<number> Words <left_right> = {Esc}$1{Alt+$2};
[One]    Word  <left_right> =        {Alt+$1};

Kill (Char | 1) = {Ctrl+d};
Kill      <number> = {Esc}$1{Ctrl+d};
Kill Back <number> = {Esc}$1{Backspace};

<editword> := ( Kill      = {Alt+d} 
              | Kill Back = {Alt+Backspace}
              | Copy      = {Alt+d}{Ctrl+y}
              | Cap       = {Alt+c}
              | Up Case   = {Alt+u}
              | Down Case = {Alt+l}
              );
<editword> Word = $1;
<editword> This Word = {Alt+b} $1;
<editword> <number> Words = {Esc} $2 $1;

### Editing Lines, Paragraphs, etc.

<edit> := ( Select    = "" 
          | Copy      = {Alt+w}
          | Duplicate = {Alt+w}{Ctrl+y}
          | Kill      = {Ctrl+w}
          );
<thing>          := ( That          = ""
                    | Line          = {Ctrl+a}{Ctrl+Space}{Ctrl+n}   
                    | Graph         = {Alt+h}                        
                    | (Flow | All)  = {Ctrl+x}h                      
                    );
<start_of_thing> := ( Word          = {Alt+b}
                    | Line          = {Ctrl+a}
                    | Graph         = {Esc}{
                    | (Flow|Buffer) = {Alt+<}
                    );
<end_of_thing>   := ( Word          = {Alt+f}
                    | Line          = {Ctrl+e}
                    | Graph         = {Esc}}
                    | (Flow|Buffer) = {Alt+>}
                    );

<start_of_thing> Start = $1;
<start_of_thing> Start <number> = {Esc} $2 $1;
  <end_of_thing> End   = $1;
  <end_of_thing> End   <number> = {Esc} $2 $1;

<edit>        <end_of_thing>  Here  = {Ctrl+Space} $2 $1;
<edit> Back <start_of_thing> [Here] = {Ctrl+Space} $2 $1;

<edit> <thing> = $2 $1;

<edit>       Here  = {Ctrl+Space}{Ctrl+e} $1;
<edit> Back [Here] = {Ctrl+Space}{Ctrl+a} $1;

<edit>      <number> Lines = {Ctrl+a}{Ctrl+Space}{Esc} $2 {Ctrl+n} $1;
<edit> Back <number> Lines = {Ctrl+a}{Ctrl+Space}{Esc} $2 {Ctrl+p} $1;

Newline Indent = {Ctrl+j};
Line  Here = {Ctrl+o};
Graph Here = {Ctrl+o}{Ctrl+o};
Open Graph = {Enter}{Ctrl+o};
Join Line = {Ctrl+u}{Alt+x}delete-indentation{Enter};
Fill Graph = {Alt+q};

### Copy/Paste

Paste That = {Ctrl+y};
Paste Here = ButtonClick(1,1) {Ctrl+y};
Yank  That = {Ctrl+y};
Yank Again = {Alt+y};

Set Mark = {Ctrl+Space};
[Set] Mark Here = ButtonClick(1,1) {Ctrl+Space};
Switch Mark = {Ctrl+x}{Ctrl+x};

Copy  To   <number> = {Alt+x}copy-to-register{Enter} $1;
Paste From <number> = {Alt+x}insert-register{Enter} $1;

Kill And Paste = {Alt+<} {Ctrl+y} {Ctrl+Space} {Alt+>} {Ctrl+w};
Copy And Switch        = {Ctrl+x}h{Alt+w} Wait(0) SendSystemKeys({Alt+Tab});
Copy And Switch Buffer = {Ctrl+x}h{Alt+w} {Alt+x}get-next-buffer{Enter};
Copy To Natspeak       = {Ctrl+x}h{Alt+w} AppBringUp(NatSpeak);
Mail That = {Ctrl+x}h{Alt+w} HeardWord(Switch, to, Netscape) Wait(500)
            {Ctrl+m} Wait(1000) "{Tab 2}{Ctrl+v}{Shift+Tab 2}";

### Indenting
Indent   <number> = {Esc} $1 {Ctrl+x}{Ctrl+i};
Unindent <number> = {Esc} $1 {Ctrl+f}{Ctrl+x}rk;
Prefix Region = {Alt+x}inleft{Enter};

# ---------------------------------------------------------------------------
# Navigation

### Scrolling
Center Cursor = {Ctrl+l};
Page (Up=PgUp | Down=PgDn)          = {$1};
Page (Up=PgUp | Down=PgDn) <number> = "{$1 $2}";
Half (Up=backward | Down=forward) = {Alt+x}scroll-window- $1 -half{Enter};
Scroll (up|down) <number> = {Esc} $2 {Alt+x}scroll- $1 {Enter};

### Search/Replace
Find Down = {Ctrl+s};
Find Up   = {Ctrl+r};
Find Again [Down] = {Ctrl+s}{Ctrl+s};
Find Again Up     = {Ctrl+r}{Ctrl+r};
Find (Word|That) [Down] = {Ctrl+s}{Ctrl+w}{Ctrl+s};
Find (Word|That)  Up    = {Ctrl+r}{Ctrl+w}{Ctrl+r};
Find <number> Words [Down] = "{Ctrl+s}{Ctrl+w $1}{Ctrl+s}";
Find <number> Words  Up    = "{Ctrl+r}{Ctrl+w $1}{Ctrl+r}";
Replace String = {Alt+x}replace-string{Enter};
Query Replace = {Esc}%;
Query Replace Regular Expression = {Alt+x}query-replace-regexp{Enter};

### Bookmarks
Set Bookmark <number> = {Ctrl+x}rm $1 {Enter};
Bookmark     <number> = {Ctrl+x}rb $1 {Enter};

### Miscellaneous
Undo That  = {Ctrl+x}u;
Abort That = {Ctrl+g};
Say Yes = yes{Enter};
Say No  =  no{Enter};
Kill White Space = {Esc}\ ;
One Space = {Alt+Space};
Do Macro = {Ctrl+x}e;
(Sort|Keep|Flush) Lines = {Alt+x}$1-lines{Enter};
Hide 0..32 = {Esc}$1{Ctrl+x}$;

Indent Region = {Alt+x}indent-region{Enter};

# ---------------------------------------------------------------------------
# Context-Sensitive Commands

### Editing Perl files
.pl:
  Insert Hash Reference = ->{}{Ctrl+b};
  Insert Subroutine = "{Enter}sub {Enter}{{Enter 2}}{Enter}{Ctrl+b 6}";
  New Statement = {Ctrl+e}{Ctrl+j};
  New Statement Above = {Ctrl+a}{Ctrl+b}{Ctrl+j};
  Statement (Start="" | Down={Ctrl+n} | Up={Ctrl+p}) = $1 {Ctrl+a}{Ctrl+i};

### Editing Java files
.java:
  New Statement = {Ctrl+e}{Ctrl+j};
  New Statement Above = {Ctrl+a}{Ctrl+b}{Ctrl+j};
  Statement (Start="" | Down={Ctrl+n} | Up={Ctrl+p}) = $1 {Ctrl+a}{Ctrl+i};

### Editing C++ files
.cpp:
  New Statement = {Ctrl+e}{Ctrl+j};
  New Statement Above = {Ctrl+a}{Ctrl+b}{Ctrl+j};
  Statement (Start="" | Down={Ctrl+n} | Up={Ctrl+p}) = $1 {Ctrl+a}{Ctrl+i};

### Shell Commands
*shell*:
  Go Up = "cd ..{Enter}";
  Go Up (2=../.. | 3=../../.. | 4=../../../..) = "cd $1{Enter}";
  Command (Up=p | Down=n) = {Alt+$1};
  Command (Up=p | Down=n) Go = {Alt+$1}{Enter};
  Command (Up=p | Down=n) 1..30 = "{Alt+$1 $2}";
  Command (Up=p | Down=n) 1..30 Go = "{Alt+$1 $2}{Enter}";
